turf
	icon = 'Sprites.dmi'
	icon_state = "back"

var
	gridx = world.maxx * 32
	gridy = world.maxy * 32
	grid
	turfs
	size = 1
	maploaded = 0

world/New()
	..()
	var/L[world.maxx][world.maxy]
	turfs = L
	for(var/turf/t in world)
		var/icon/i = new(t.icon)
		turfs[t.x][t.y] = i

proc/Displace(num)
	var max = num / (world.maxx/size * 32 + world.maxy/size * 32) * 3;
	return (rand(0,10)/10 - 0.5) * max;

/*proc/ComputeColor(c)
	var
		Red = 0;
		Green = 0;
		Blue = 0;
	if(c >= 0.58)return rgb((1 - c + 0.1)*400,0, 0);
	if(c > 0.6)return rgb((1 - c + 0.1)*300,0, 0);
	if(c > 0.5)Red = c*20 * 2;
	if(c >= 0.5)Red = (c - 0.5)*200 * 2;
	if(c >= 0.57 && c < 0.58)
		Green = (c)*150 * 2;
		Red = (c)*150 * 2;
		Blue = (c)*100 * 2;
	else if(c >= 0.58 && c < 0.6)
		Green = (c)*50 * 2;
		Blue = (c)*100 * 2;
	else if(c >= 0.3 && c < 0.6)
		Green = (c - 0.2)*200 * 2;
		Blue = (c - 0.2)*100 * 2;
		Red = (c - 0.2)*200 * 2;
	else if (c < 0.3)
		Green = (0 + (0.4 - c))*100 + ((0.6 - c) * 10) * 2;
		Blue = (0 + (0.4 - c))*100 + ((0.6 - c) * 10) * 2;
		Red = (0 + (0.4 - c))*200 + ((0.6 - c) * 10) * 2;
	return rgb(round(Red), round(Green), round(Blue));*/

proc/ComputeColor(c)
	var
		Red = 0;
		Green = 0;
		Blue = 0;
	if(c >= 0.58)return rgb(0, 0, (1 - c + 0.1)*400);
	if(c > 0.6)return rgb(0, 0, (1 - c + 0.1)*300);
	if(c > 0.5)Red = c*20 * 2;
	if(c >= 0.5)Blue = (c - 0.5)*200 * 2;
	if(c >= 0.57 && c < 0.58)
		Green = (c)*150 * 2;
		Red = (c)*150 * 2;
		Blue = (c)*20 * 2;
	else if(c >= 0.58 && c < 0.6)
		Green = (c)*50 * 2;
		Blue = (c)*100 * 2;
	else if(c >= 0.3 && c < 0.6)Green = (c - 0.2)*200 * 2;
	else if (c < 0.3)Green = (0 + (0.4 - c))*200 + ((0.6 - c) * 10) * 2;
	return rgb(round(Red), round(Green), round(Blue));

proc/drawPlasma(list/g, width, height)
	var c1, c2, c3, c4;

	c1 = rand(0,10)/10;
	c2 = rand(0,10)/10;
	c3 = rand(0,10)/10;
	c4 = rand(0,10)/10;

	var/list/edited = list()
	world<<"Loading..."
	sleep(1)
	percentmax = 1
	while(percentmax < gridx*gridy)percentmax *= 4
	percentloaded = 0
	var/L[gridx][gridy]
	DivideGrid(g, 0, 0, width , height , c1, c2, c3, c4, edited, L);
	grid = L
	world<<"[percentloaded] pixels drawn"
	world<<"[gridx * gridy] pixels on the map"
	for(var/turf/t in edited)t.icon = turfs[t.x][t.y]

proc/DivideGrid(list/g, x, y, width, height, c1, c2, c3, c4, list/e, L)
	var Edge1, Edge2, Edge3, Edge4, Middle;
	var newWidth = width / 2;
	var newHeight = height / 2;

	if (width > 1 || height > 1)
		Middle = (c1 + c2 + c3 + c4) / 4 + Displace(newWidth + newHeight);
		Edge1 = (c1 + c2) / 2;
		Edge2 = (c2 + c3) / 2;
		Edge3 = (c3 + c4) / 2;
		Edge4 = (c4 + c1) / 2;

		if (Middle < 0)
		{
			Middle = 0;
		}
		else if (Middle > 1.0)
		{
			Middle = 1.0;
		}
		DivideGrid(g, x, y, newWidth, newHeight, c1, Edge1, Middle, Edge4, e, L);
		DivideGrid(g, x + newWidth, y, newWidth, newHeight, Edge1, c2, Edge2, Middle, e, L);
		DivideGrid(g, x + newWidth, y + newHeight, newWidth, newHeight, Middle, Edge2, c3, Edge3, e, L);
		DivideGrid(g, x, y + newHeight, newWidth, newHeight, Edge4, Middle, Edge3, c4, e, L);
	else
		var c = (c1 + c2 + c3 + c4) / 4;
		var/turf/t = locate((x + 32 - x % 32) / 32, (y + 32 - y % 32) / 32, 1)
		if(!e.Find(t))e += t
		var/icon/i = turfs[t.x][t.y]
		i.DrawBox(ComputeColor(c), x % 32 + 1, y % 32 + 1)
		percentloaded++
		if(percentloaded % 50000 == 0)
			world<<"[round(percentloaded/percentmax * 100)] % Loaded"
			sleep(1)
		L[x+1][y+1] = c

var
	percentloaded = 1
	percentmax = 0

mob/verb/Generate_Map()
	drawPlasma(turfs, world.maxx/size*32, world.maxy/size*32);
	maploaded = 1